Program _25_;
{Startovni cislo 25}
Uses Crt,Graph;
Type IDType=String[10];

Type Osoba=record
 id       :IDType;
 jmeno    :String[32];
 prijmeni :String[32];
 pohlavi  :Boolean; {true = Muz; false = zena}
 narozeni :Integer;
 umrti    :Integer;
 matka    :IDType;
 otec     :IDType;
 x,y,r    :Integer;
 z        :Boolean;

end;

Type POsoba=^Osoba; {Ukazatel na zaznam osoba}

Var Data           :Array[0..1000] of POsoba; {max pocet osob je 1000 -> 4 KB pameti}
    PocetOsob      :Integer; {pocet nacitanych osob}
    GD,GM          :Integer; {promenne pro inicializaci grafiky}
    I,POZ          :Integer; {pomocne promenne}
    pocrad         :Integer; {pocet rad v grafu}
    px,py          :Integer; {poloha v grafu X, Y}
    OsobaX         :Osoba;
    ch             :Char; {Znak stisknuty na klavesnici}

{Procedure PridejOsobu(id:IDType;matka,otec:IDType);
 begin
 end;}

Function Num(X:Boolean):Byte;
 begin
  if x then num:=1 else num:=0;
 end;

Function OsID(hl_ID:IDType):Integer; {vrati cislo osoby z danym ID}
 var I2:Integer;
 begin
   For I2 := 1 to pocetosob do if data[i2]^.id = hl_id then
    begin osid:=i2; exit; end;
   osid:=0;      {Nenajde-li vrati nulu}
 end;

Procedure VypoctiStrom;
 var udelano, rada:Integer;
 begin
   Rada:=0;
   udelano:=0;
   For I:= 1 to pocetosob do begin data[i]^.r:=0; data[i]^.z:=false; end;
   repeat
    inc(rada);
    For I:= 1 to pocetosob do
     if (data[i]^.r=0) then
     begin
      if ((data[i]^.matka = '') OR (data[OsID(data[i]^.matka)]^.z =true))
       AND ((data[i]^.otec = '') OR (data[OsID(data[i]^.otec)]^.z =true)) then
        begin
          data[i]^.r:=rada; inc(udelano);
        end;
     end;

    For I:= 1 to pocetosob do
     if (data[i]^.r=rada) then
        begin
          if data[OsID(data[i]^.matka)]^.r=rada then begin data[i]^.r:=0; dec(udelano); end else
          if data[OsID(data[i]^.otec)]^.r=rada then begin data[i]^.r:=0;dec(udelano); end;
          if (data[i]^.r=rada) then data[i]^.z:=true;


        end;
   until udelano>=pocetosob;
  pocrad:=rada;
 end;

Procedure ZobrazStrom2(ax,ay:Integer); {Zobrazi strom ktery umisti dane lidi na dane radky}
 var rada,pozice:Integer;
 begin
  SetTextJustify(CenterText,CenterText); {Vycentruje polohu textu}

   For rada:= 1 to pocrad do
    begin pozice:=0;
    For I:= 1 to pocetosob do
     if (data[i]^.r=rada) then
      begin
         data[i]^.x:=pozice*100+TextWidth(data[i]^.jmeno[1]+'.'+data[i]^.prijmeni) div 2; inc(pozice);
         data[i]^.y:=rada*40;
         if (ax=pozice) and (ay=rada-1) then setcolor(12) else SetColor(15);{nastavi barvu cervenou kdyz je polozka aktivni}
         outtextxy(data[i]^.x,data[i]^.y,data[i]^.jmeno[1]+'.'+data[i]^.prijmeni);
          {Prvni pismeno krest.jm a prijmeni vypise na obrazovku}

         SetColor(11); {spojnice k otci a matce}
         if (data[i]^.otec <> '') then line(data[i]^.x,data[i]^.y
             ,data[OsID(data[i]^.otec)]^.x,data[OsID(data[i]^.otec)]^.y);
          SetColor(14);
          if (data[i]^.matka <> '') then line(data[i]^.x,data[i]^.y
            ,data[OsID(data[i]^.matka)]^.x,data[OsID(data[i]^.matka)]^.y);
          if data[i]^.pohlavi then SetColor(11) else SetColor(14);
          line(data[i]^.x-8,data[i]^.y+6,data[i]^.x+8,data[i]^.y+6); {barevne pruhy urcujici pohlavi}
          line(data[i]^.x-8,data[i]^.y-6,data[i]^.x+8,data[i]^.y-6);
      end;
   end;
 end;


Procedure NactiZeSouboru(JmenoS:String);
 var F      :Text;
     s,el,uel :String;
     chyba  :Boolean;
     id,jmeno,prijmeni,pohlavi,narozeni,umrti,matka,otec:Boolean;
     rodokmen,osoba   :Boolean;
     soucet:Byte;
     Stav    :boolean;  {jsem uvnitr elementu?}

 Procedure ZpracujEl;
  begin
   if el = 'rodokmen' then rodokmen:=true else
   if el = '/rodokmen' then rodokmen:=false else
   if el = 'osoba' then
    begin
      osoba:=true; inc(pocetosob); new(data[pocetosob]);
      fillchar(data[pocetosob]^,sizeof(data[pocetosob]^),0);
    end else
   if el = '/osoba' then
   osoba:=false
   else

   if el = 'id' then id:=true else
   if el = '/id' then id:=false else

   if el = 'jmeno' then jmeno:=true else
   if el = '/jmeno' then jmeno:=false else
   if el = 'prijmeni' then prijmeni:=true else
   if el = '/prijmeni' then prijmeni:=false else
   if el = 'pohlavi' then pohlavi:=true else
   if el = '/pohlavi' then pohlavi:=false else
   if el = 'narozeni' then narozeni:=true else
   if el = '/narozeni' then narozeni:=false else
   if el = 'umrti' then umrti:=true else
   if el = '/umrti' then umrti:=false else
   if el = 'matka' then matka:=true else
   if el = '/matka' then matka:=false else
   if el = 'otec' then otec:=true else
   if el = '/otec' then otec:=false else

  end;

 Procedure Kontrola;
  begin
    if (soucet > 1) OR ((soucet=1) and not(osoba)) or (osoba and not(rodokmen))
        then chyba:=true;
  end;

 Procedure VlozitData;
  var pmi:Integer;
  begin
   if soucet=1 then
    begin
     if otec then data[pocetosob]^.otec:=UEl else
     if matka then data[pocetosob]^.matka:=UEl else
     if id then data[pocetosob]^.id:=UEl else
     if jmeno then data[pocetosob]^.jmeno:=UEl else
     if prijmeni then data[pocetosob]^.prijmeni:=UEl else
     if pohlavi then data[pocetosob]^.pohlavi:=(UEl<>'Z') else
     if narozeni then val(UEl,data[pocetosob]^.narozeni,pmi) else
     if umrti then val(UEl,data[pocetosob]^.umrti,pmi) else
    end;
  end;

 Procedure ZpracujRadek(Ra:String);
   begin
     For I:= 1 to Length(Ra) do
      begin
       if (Ra[I]='<') and (not stav) then
         begin
           VlozitData;
           stav:=true; el:='';
         end else
       if (Ra[I]='>') and (stav) then begin stav:=false; zpracujel; UEL:=''; end else
       if stav then el:=el+ra[i];

       soucet:=num(otec)+ num(matka)+ num(umrti)+ num(narozeni) + num(pohlavi)+num(prijmeni)+ num(jmeno)+ num(id);
       kontrola;

       if (soucet = 1) and not(stav) and (ra[i]<>'>') then UEl:=UEl+Ra[I];
      end;
   end;

 begin
   chyba:=false;
   Assign(F,JmenoS);
   Reset(F);
   osoba:=false;rodokmen:=false;
   otec:=false;matka:=false; id:=false;prijmeni:=false;jmeno:=false;
   pohlavi:=false;   narozeni:=false;   umrti:=false; uel:='';
   stav:=false;
   While not(eof(f) or chyba) do
    begin
      Read(f,s);
      ZpracujRadek(s);
    end;
   Close(F);
   If Chyba then begin WriteLn('Chyba pri nacitani ze souboru!!'); halt; end;
 end;

procedure vyber;
  var sy:Byte; {sipka Y}
     ch2:Char;
     pmi,i2:Integer;
     ps:String;
 Procedure KresliSipku;
  begin
   gotoxy(17,sy-1); Write('  ');
   gotoxy(17,sy); Write('>>');
   gotoxy(17,sy+1); Write('  ');
  end;
 begin
   sy:=8;
   repeat
       kreslisipku;
        ch2:=readkey;
        case ch2 of
         #0:case readkey of
          'H':if sy > 8 then Dec(sy);
          'P':if sy < 19 then inc(sy);
         end;
         #13:
          begin
           gotoxy(30,sy); Write('                            ');
           gotoxy(30,sy);
           case sy of
             9: Readln(data[i]^.jmeno);
             10: Readln(data[i]^.prijmeni);
             12: begin Readln(ps); data[i]^.pohlavi:= (ps<>'Z') end;
             13: begin Readln(ps); val(copy(ps,1,4),data[i]^.narozeni,pmi); val(copy(ps,6,4),data[i]^.umrti,pmi); end;
             18: begin {mazani polozky}
                   for pmi:= 1 to pocetosob do
                    begin
                      if data[pmi]^.otec=data[i]^.id then data[pmi]^.otec:='';
                      if data[pmi]^.matka=data[i]^.id then data[pmi]^.matka:='';
                    end;


                   dispose(data[i]);
                   for pmi:= i+1 to pocetosob do
                    begin
                     data[pmi-1]:= data[pmi];
                    end;
                   dec(pocetosob);
                 end;
             19: begin {prejit na pribuznou osobu}
                    setcolor(13); setfillstyle(1,0);
                    Bar3d(100,90,540,380,0,topoff);            {Nakresli ramecek}

        GotoXY(20,9); Write('1. manzel/ka');
        GotoXY(20,10); Write('2. dite');
        GotoXY(20,11); Write('3. otec');
        GotoXY(20,12); Write('4. matka');
        GotoXY(20,14); Write('Stiskni cislo(1-4)');
        pmi:=0;
        case readkey of
         '1': for i2:=1 to pocetosob do if (data[i2]^.otec = data[i]^.id) or (data[i2]^.matka = data[i]^.id) then
                 begin
                  if data[i2]^.otec = data[i]^.id then pmi:=osid(data[i2]^.matka) else pmi:=osid(data[i2]^.otec);
                  break;
                 end;
         '2': for i2:=1 to pocetosob do if (data[i2]^.otec = data[i]^.id) or (data[i2]^.matka = data[i]^.id) then pmi:=i2;
         '3': pmi:=osid(data[i]^.otec);
         '4': pmi:=osid(data[i]^.matka);
                 end;
         if pmi <> 0 then
          begin
            py:=data[pmi]^.r-1; i:=pmi;
            px:=1;
            For I2:= 1 to pmi-1 do {najde cislo sloupce kde lezi akt. udaj}
             if (data[i2]^.r=py+1) then
                begin
                 inc(px);
                end;
          end;
                end;
            end;
           ch2:=#27;
          end;
        end;
  until ch2=#27;
 end;

Procedure Pridejpolozku;
 begin
   OsobaX.jmeno:='Jan';
   OsobaX.prijmeni:='Novak';
   OsobaX.pohlavi:=true;
   OsobaX.narozeni:=0;
   OsobaX.umrti:=0;
   OsobaX.matka:='';
   OsobaX.otec:='';
       poz:=0;
       For I:= 1 to pocetosob do {najde cislo sloupce kde lezi akt. udaj}
        if (data[i]^.r=py+1) then
          begin
            inc(poz);
            if (px=poz) then break;
          end;
       if (i = pocetosob) and (px <> poz) then i:=0;
   if data[i]^.pohlavi then OsobaX.otec:=data[i]^.id else OsobaX.matka:=data[i]^.id;

   inc(pocetosob);
   new(data[pocetosob]);
   data[pocetosob]^:=osobax;
   VypoctiStrom;
 end;

Procedure SaveToFile; {Ulozi do souboru}
 var f:Text;
 begin
  assign(f,'vystup.xml');
  rewrite(f);
  writeLn(f,'<rodokmen>');
  for I:= 1 to pocetosob do
   begin
    writeLn(f,'<osoba>');
    writeLn(f,'<id>'); writeln(f,data[i]^.id); writeLn(f,'</id>');
    writeLn(f,'<jmeno>'); writeln(f,data[i]^.jmeno); writeLn(f,'</jmeno>');
    writeLn(f,'<prijmeni>'); writeln(f,data[i]^.prijmeni); writeLn(f,'</prijmeni>');
    writeLn(f,'<pohlavi>'); writeln(f,data[i]^.pohlavi); writeLn(f,'</pohlavi>');
    writeLn(f,'<narozeni>'); writeln(f,data[i]^.narozeni); writeLn(f,'</narozeni>');
    writeLn(f,'<umrti>'); writeln(f,data[i]^.umrti); writeLn(f,'</umrti>');
    writeLn(f,'<matka>'); writeln(f,data[i]^.matka); writeLn(f,'</matka>');
    writeLn(f,'<otec>'); writeln(f,data[i]^.otec); writeLn(f,'</otec>');
    writeLn(f,'</osoba>');
   end;
  writeLn(f,'</rodokmen>');
  close(f);
 end;

BEGIN
 PocetOsob:=0; {Pocatecni pocet osob je nulovy}

 new(data[0]); data[0]^.jmeno:='-';data[0]^.prijmeni:=''; {nadefinuje nulovou osobu ktera se zobrazi pri chybnem vyberu}
 data[0]^.narozeni:=0; data[0]^.umrti:=0;

 NactiZeSouboru(ParamStr(1)); {nacte ze souboru XML}
 InitGraph(GD,GM,''); {inicializuje grafiku}
 directvideo:=false; {Umozni vypis na grafickou obrazovku pomoci Write}
 VypoctiStrom;{Vypocita polohy polozek v jednotilivych radach}
 px:=1;py:=0;
 repeat
  cleardevice; {Premaze obrazovku}
  Gotoxy(1,1); Write('RODOKMEN 25 - Sipkami se pohybuje, Enter- editace, S-ulozit');
  Gotoxy(1,1);
  ZobrazStrom2(px,py); {Nakresli uz predem vypocitany graf-strom}
  ch:= readkey; {Nacita klavesu z klavesnice}
  case ch of
   #0: case readkey of  {navigace v grafu pomoci kurzorovych sipek}
         'H':If py > 0 then dec(py);
         'P':If py < pocrad-1 then inc(py);
         'G':px:=1; {Home - presune se na zacatek radku}
         'K':If px > 1 then dec(px);
         'M':inc(px);
        end;
    '+': PridejPolozku; {prida polozku jako dite dane osoby}
    #13: {zobrazi kompletni informace o dane osobe}
     begin
       setcolor(13); setfillstyle(1,0); {nastaveni barvy okraje a vypne ramecku}
       Bar3d(100,90,540,380,0,topoff);            {Nakresli ramecek}

       poz:=0;
       For I:= 1 to pocetosob do {najde cislo sloupce kde lezi akt. udaj}
        if (data[i]^.r=py+1) then
          begin
            inc(poz);
            if (px=poz) then break;
          end;
       if (i = pocetosob) and (px <> poz) then i:=0;

       textattr:=15; {Vypise udaje o vybrane osobe}
        GotoXY(20,9); Write('   Jmeno: ',data[i]^.jmeno);
        GotoXY(20,10); Write('Prijmeni: ',data[i]^.prijmeni);
       GotoXY(20,12); Write(' Pohlavi: '); if data[i]^.pohlavi then Write('M') else Write('Z');
       GotoXY(20,13); Write('   Zivot: ',data[i]^.narozeni,'-',data[i]^.umrti);
       GotoXY(20,15); Write('   Matka: ',data[OSID(data[i]^.matka)]^.jmeno+' '+data[OSID(data[i]^.matka)]^.prijmeni);
       GotoXY(20,16); Write('    Otec: ',data[OSID(data[i]^.otec)]^.jmeno+' '+data[OSID(data[i]^.otec)]^.prijmeni);
       GotoXY(20,18); Write('Smazat');
       GotoXY(20,19); Write('Prejit na');
       vyber; {Interaktivni nabidka na upravovani polozky, jeji smazani, nebo na prechod na pribuznou osobu}
       VypoctiStrom; {Znovu prepocita cely strom}
     end;
    's','S':SaveToFile;
   end;
 until ch=#27; {program se ukonci stiskem klavesy ESC}
 for I:= 0 to pocetosob do dispose(data[i]); {vyprazdni pamet}
 CloseGraph;
END.